#include "stdafx.h"
#include "TestCertDialog.h"
#include "TestCertDialogDlg.h"
#include "SelectCertificateDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#pragma warning(suppress: 26455)
CTestCertDialogDlg::CTestCertDialogDlg(_In_opt_ CWnd* pParent) : CDialog{CTestCertDialogDlg::IDD, pParent},
                                                                 m_hIcon{AfxGetApp()->LoadIcon(IDR_MAINFRAME)}
{
}

void CTestCertDialogDlg::DoDataExchange(CDataExchange* pDX)
{
  __super::DoDataExchange(pDX);
}

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CTestCertDialogDlg, CDialog) //NOLINT(modernize-avoid-c-arrays)
  ON_WM_PAINT()
  ON_WM_QUERYDRAGICON()
  ON_BN_CLICKED(IDC_BUTTON1, &CTestCertDialogDlg::OnButton1)
END_MESSAGE_MAP()

BOOL CTestCertDialogDlg::OnInitDialog()
{
  //Let the base class do its thing
  __super::OnInitDialog();

  SetIcon(m_hIcon, TRUE);
  SetIcon(m_hIcon, FALSE);

  return TRUE;
}

#pragma warning(suppress: 26434)
void CTestCertDialogDlg::OnPaint()
{
  if (IsIconic())
  {
    CPaintDC dc{this}; //device context for painting

#pragma warning(suppress: 26490)
    SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

    //Center icon in client rectangle
    const int cxIcon{GetSystemMetrics(SM_CXICON)};
    const int cyIcon{GetSystemMetrics(SM_CYICON)};
    CRect rect;
    GetClientRect(&rect);
    const int x{(rect.Width() - cxIcon + 1) / 2};
    const int y{(rect.Height() - cyIcon + 1) / 2};

    //Draw the icon
    dc.DrawIcon(x, y, m_hIcon);
  }
  else
    __super::OnPaint();
}

#pragma warning(suppress: 26434 26440)
HCURSOR CTestCertDialogDlg::OnQueryDragIcon()
{
#pragma warning(suppress: 26473)
  return static_cast<HCURSOR>(m_hIcon);
}

void CTestCertDialogDlg::OnButton1()
{
  //For testing purposes, lets open the local machine certificate store
  HCERTSTORE hStoreHandle{CertOpenStore(CERT_STORE_PROV_SYSTEM, 0, NULL, CERT_SYSTEM_STORE_LOCAL_MACHINE | CERT_STORE_MAXIMUM_ALLOWED_FLAG, L"My")};
  VERIFY(hStoreHandle != nullptr);

  CSelectCertificateDlg dlg{this};

  //Customize some of the dialogs values
  dlg.m_hCertStore = hStoreHandle;
  dlg.m_bAllowMultipleSelection = true;
  //dlg.m_bHideViewCertificateButton = true;

  /*
  //Find the second cert in the store and specify it as the one to initially select
  PCCERT_CONTEXT pFoundCert{CertFindCertificateInStore(hStoreHandle, 0, 0, CERT_FIND_ANY, nullptr, nullptr)};
  ASSERT(pFoundCert);
  PCCERT_CONTEXT pFoundCert2{CertFindCertificateInStore(hStoreHandle, 0, 0, CERT_FIND_ANY, nullptr, pFoundCert)};
  ASSERT(pFoundCert2);
  dlg.SetInitialSelectedCert(pFoundCert2);
  dlg.SetInitialSelectedCert(pFoundCert2);
  CertFreeCertificateContext(pFoundCert2);
  */

  //Show the dialog
  dlg.DoModal();

  //Exercise some of the functions now that the dialog has returned
  /*
  INT_PTR nCerts{dlg.GetCertificatesShownCount()};
  UNREFERENCED_PARAMETER(nCerts);
  bool bWasSelected{false};
  PCCERT_CONTEXT pCertContext{dlg.GetCertificateShown(0, bWasSelected)};
  CertFreeCertificateContext(pCertContext);
  INT_PTR nIndex{0};
  pCertContext = dlg.GetNextSelectedCertificateShown(nIndex);
  while (pCertContext)
  {
    //Prepare for the next time around
    CertFreeCertificateContext(pCertContext);
    nIndex++;
    pCertContext = dlg.GetNextSelectedCertificateShown(nIndex);
  }
  */

  CertCloseStore(hStoreHandle, 0);
}
